Subject: [bug#47615] [PATCH 1/9] gnu: bootstrap: Add support for powerpc-linux.

From: Efraim Flashner <[email-masked]>
Date: Wed, 5 May 2021 11:51:17 +0300

On Tue, May 04, 2021 at 06:52:31PM -0700, Chris Marusich wrote:
> Chris Marusich <[email-masked]> writes:
> 
> > Efraim Flashner <[email-masked]> writes:
> >
> >> On 923bb70a1bff657125c3008f119a477e5cb57c2b
> >>    gnu:glibc-for-bootstrap: Fix patch.
> >>
> >> Run
> >>     ./pre-inst-env guix build --target=powerpc-linux-gnu bootstrap-tarballs
> g>>
> >> Producing
> >>
> >>     /gnu/store/dyj1wvayyp1ihaknkxniz1xamcf4yrhl-bootstrap-tarballs-0
> >>
> >> With guix hash -rx /gnu/store/dyj1wvayyp1ihaknkxniz1xamcf4yrhl-bootstrap-tarballs-0
> >>
> >>     02xx2ydj28pwv3vflqffinpq1icj09gzi9icm8j4bwc4lca9irxn
> >
> > Generally speaking, this patch looks fine to me.  Just curious, what
> > sort of machines does one use for 32-bit powerpc?
> >
> > I want to build the bootstrap binaries, see if they're reproducible (in
> > particular GCC, which I suspect won't be), and verify the hashes.
> >
> > It might take a few days to do that, but I'll update this thread once
> > I've done it.
> 
> I repeated Efraim's steps on two different x86_64-linux Guix System
> machines.  In both cases, it produced exactly the same hash.  Therefore,
> it would seem these bootstrap binaries are actually reproducible.  I was
> surprised by this because of my experience with bug 41669.  I expected
> GCC to not be reproducible, but in this case it seems reproducible.
> 
> I wonder what's different?  The powerpc64 architecture is 64-bit, and
> powerpc is 32-bit, but I wonder what else might be different that could
> cause the non-reproducibility to occur only in the powerpc64-linux
> case.
> 
> Anyway, this is good news for the powerpc-linux port.  It is also an
> interesting clue for the investigation of bug 41669, but further
> discussion about that should go there, not here.
> 

In terms of what is more relevant here, IIRC there is some CI code to
build cross toolchain stuff to powerpc-linux-gnu. Is it possible that
you reused some of that? I don't remember exactly from the other bug
report which bits suddenly made the difference. Otherwise I built mine
about 4 months earlier.

-- 
Efraim Flashner   <[email-masked]>   אפרים פלשנר
GPG key = A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
Confidentiality cannot be guaranteed on emails sent or received unencrypted